---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Digital pattern generator
---------------------------------------------------------------------------------------
-- File           : wb_PatternGenerator.vhd
-- Author         : auto-generated by wbgen2 from gen_PatternGenerator.wb
-- Created        : 09/25/12 09:46:18
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE gen_PatternGenerator.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity wb_PatternGenerator is
  port (
-- 
    rst_n_i                                  : in     std_logic;
-- 
    wb_clk_i                                 : in     std_logic;
-- 
    wb_addr_i                                : in     std_logic_vector(1 downto 0);
-- 
    wb_data_i                                : in     std_logic_vector(31 downto 0);
-- 
    wb_data_o                                : out    std_logic_vector(31 downto 0);
-- 
    wb_cyc_i                                 : in     std_logic;
-- 
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
-- 
    wb_stb_i                                 : in     std_logic;
-- 
    wb_we_i                                  : in     std_logic;
-- 
    wb_ack_o                                 : out    std_logic;
-- Ports for PASS_THROUGH field: 'data_in' in reg: 'Pattern data input'
    wbpattern_data_in_o                      : out    std_logic_vector(31 downto 0);
    wbpattern_data_in_wr_o                   : out    std_logic;
-- Port for std_logic_vector field: 'period' in reg: 'Pattern period time'
    wbpattern_period_period_o                : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Enable' in reg: 'Pattern control'
    wbpattern_control_enable_o               : out    std_logic_vector(0 downto 0);
-- Port for std_logic_vector field: 'Load pattern' in reg: 'Pattern control'
    wbpattern_control_load_o                 : out    std_logic_vector(0 downto 0);
-- Ports for PASS_THROUGH field: 'Stop pattern' in reg: 'Pattern control'
    wbpattern_control_stop_o                 : out    std_logic_vector(0 downto 0);
    wbpattern_control_stop_wr_o              : out    std_logic;
-- Ports for PASS_THROUGH field: 'Soft trigger' in reg: 'Pattern control'
    wbpattern_control_softtrigger_o          : out    std_logic_vector(0 downto 0);
    wbpattern_control_softtrigger_wr_o       : out    std_logic;
-- Port for std_logic_vector field: 'Pattern busy' in reg: 'Pattern Status'
    wbpattern_status_pattern_busy_i          : in     std_logic_vector(0 downto 0);
-- Port for std_logic_vector field: 'Not used' in reg: 'Pattern Status'
    wbpattern_status_reserved_i              : in     std_logic_vector(14 downto 0);
-- Port for std_logic_vector field: 'Pattern width' in reg: 'Pattern Status'
    wbpattern_status_width_i                 : in     std_logic_vector(7 downto 0);
-- Port for std_logic_vector field: 'Bits for pattern memory depth' in reg: 'Pattern Status'
    wbpattern_status_depthbits_i             : in     std_logic_vector(7 downto 0)
  );
end wb_PatternGenerator;

architecture syn of wb_PatternGenerator is

signal wbpattern_period_period_int              : std_logic_vector(31 downto 0);
signal wbpattern_control_enable_int             : std_logic_vector(0 downto 0);
signal wbpattern_control_load_int               : std_logic_vector(0 downto 0);
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(1 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal bus_clock_int                            : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_data_i;
  bwsel_reg <= wb_sel_i;
  bus_clock_int <= wb_clk_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (bus_clock_int, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= std_logic_vector(to_unsigned(0, 10));
      ack_in_progress <= '0';
      rddata_reg <= std_logic_vector(to_unsigned(0, 32));
      wbpattern_data_in_wr_o <= '0';
      wbpattern_period_period_int <= std_logic_vector(to_unsigned(0, 32));
      wbpattern_control_enable_int <= std_logic_vector(to_unsigned(0, 1));
      wbpattern_control_load_int <= std_logic_vector(to_unsigned(0, 1));
      wbpattern_control_stop_wr_o <= '0';
      wbpattern_control_softtrigger_wr_o <= '0';
    elsif rising_edge(bus_clock_int) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          wbpattern_data_in_wr_o <= '0';
          wbpattern_control_stop_wr_o <= '0';
          wbpattern_control_softtrigger_wr_o <= '0';
          ack_in_progress <= '0';
        else
          wbpattern_data_in_wr_o <= '0';
          wbpattern_control_stop_wr_o <= '0';
          wbpattern_control_softtrigger_wr_o <= '0';
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(1 downto 0) is
          when "00" => 
            if (wb_we_i = '1') then
              wbpattern_data_in_wr_o <= '1';
              rddata_reg(0) <= 'X';
              rddata_reg(1) <= 'X';
              rddata_reg(2) <= 'X';
              rddata_reg(3) <= 'X';
              rddata_reg(4) <= 'X';
              rddata_reg(5) <= 'X';
              rddata_reg(6) <= 'X';
              rddata_reg(7) <= 'X';
              rddata_reg(8) <= 'X';
              rddata_reg(9) <= 'X';
              rddata_reg(10) <= 'X';
              rddata_reg(11) <= 'X';
              rddata_reg(12) <= 'X';
              rddata_reg(13) <= 'X';
              rddata_reg(14) <= 'X';
              rddata_reg(15) <= 'X';
              rddata_reg(16) <= 'X';
              rddata_reg(17) <= 'X';
              rddata_reg(18) <= 'X';
              rddata_reg(19) <= 'X';
              rddata_reg(20) <= 'X';
              rddata_reg(21) <= 'X';
              rddata_reg(22) <= 'X';
              rddata_reg(23) <= 'X';
              rddata_reg(24) <= 'X';
              rddata_reg(25) <= 'X';
              rddata_reg(26) <= 'X';
              rddata_reg(27) <= 'X';
              rddata_reg(28) <= 'X';
              rddata_reg(29) <= 'X';
              rddata_reg(30) <= 'X';
              rddata_reg(31) <= 'X';
            else
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01" => 
            if (wb_we_i = '1') then
              wbpattern_period_period_int <= wrdata_reg(31 downto 0);
            else
              rddata_reg(31 downto 0) <= wbpattern_period_period_int;
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10" => 
            if (wb_we_i = '1') then
              wbpattern_control_enable_int <= wrdata_reg(0 downto 0);
              wbpattern_control_load_int <= wrdata_reg(1 downto 1);
              wbpattern_control_stop_wr_o <= '1';
              wbpattern_control_softtrigger_wr_o <= '1';
              rddata_reg(2) <= 'X';
              rddata_reg(3) <= 'X';
              rddata_reg(4) <= 'X';
              rddata_reg(5) <= 'X';
              rddata_reg(6) <= 'X';
              rddata_reg(7) <= 'X';
              rddata_reg(8) <= 'X';
              rddata_reg(9) <= 'X';
              rddata_reg(10) <= 'X';
              rddata_reg(11) <= 'X';
              rddata_reg(12) <= 'X';
              rddata_reg(13) <= 'X';
              rddata_reg(14) <= 'X';
              rddata_reg(15) <= 'X';
              rddata_reg(16) <= 'X';
              rddata_reg(17) <= 'X';
              rddata_reg(18) <= 'X';
              rddata_reg(19) <= 'X';
              rddata_reg(20) <= 'X';
              rddata_reg(21) <= 'X';
              rddata_reg(22) <= 'X';
              rddata_reg(23) <= 'X';
              rddata_reg(24) <= 'X';
              rddata_reg(25) <= 'X';
              rddata_reg(26) <= 'X';
              rddata_reg(27) <= 'X';
              rddata_reg(28) <= 'X';
              rddata_reg(29) <= 'X';
              rddata_reg(30) <= 'X';
              rddata_reg(31) <= 'X';
            else
              rddata_reg(0 downto 0) <= wbpattern_control_enable_int;
              rddata_reg(1 downto 1) <= wbpattern_control_load_int;
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "11" => 
            if (wb_we_i = '1') then
            else
              rddata_reg(0 downto 0) <= wbpattern_status_pattern_busy_i;
              rddata_reg(15 downto 1) <= wbpattern_status_reserved_i;
              rddata_reg(23 downto 16) <= wbpattern_status_width_i;
              rddata_reg(31 downto 24) <= wbpattern_status_depthbits_i;
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_data_o <= rddata_reg;
-- data_in
-- pass-through field: data_in in register: Pattern data input
  wbpattern_data_in_o <= wrdata_reg(31 downto 0);
-- period
  wbpattern_period_period_o <= wbpattern_period_period_int;
-- Enable
  wbpattern_control_enable_o <= wbpattern_control_enable_int;
-- Load pattern
  wbpattern_control_load_o <= wbpattern_control_load_int;
-- Stop pattern
-- pass-through field: Stop pattern in register: Pattern control
  wbpattern_control_stop_o <= wrdata_reg(2 downto 2);
-- Soft trigger
-- pass-through field: Soft trigger in register: Pattern control
  wbpattern_control_softtrigger_o <= wrdata_reg(3 downto 3);
-- Pattern busy
-- Not used
-- Pattern width
-- Bits for pattern memory depth
  rwaddr_reg <= wb_addr_i;
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
