---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Read 64-bits timestamp
---------------------------------------------------------------------------------------
-- File           : wb_readTimestamp.vhd
-- Author         : auto-generated by wbgen2 from gen_readTimestamp.wb
-- Created        : 09/13/12 10:14:06
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE gen_readTimestamp.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity wb_readTimestamp is
  port (
-- 
    rst_n_i                                  : in     std_logic;
-- 
    wb_clk_i                                 : in     std_logic;
-- 
    wb_addr_i                                : in     std_logic_vector(2 downto 0);
-- 
    wb_data_i                                : in     std_logic_vector(31 downto 0);
-- 
    wb_data_o                                : out    std_logic_vector(31 downto 0);
-- 
    wb_cyc_i                                 : in     std_logic;
-- 
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
-- 
    wb_stb_i                                 : in     std_logic;
-- 
    wb_we_i                                  : in     std_logic;
-- 
    wb_ack_o                                 : out    std_logic;
-- Port for std_logic_vector field: 'timestamp' in reg: 'Timestamp High Word'
    wbrdtime_high_timestamp_i                : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'timestamp' in reg: 'Timestamp Low Word'
    wbrdtime_low_timestamp_i                 : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'error_counter' in reg: 'Timestamp error counter'
    wbrdtime_errors_nr_i                     : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'correction_counter' in reg: 'Timestamp correction counter'
    wbrdtime_corrections_nr_i                : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'disable' in reg: 'Read Timestamp control'
    wbrdtime_control_disable_o               : out    std_logic_vector(0 downto 0);
-- Port for std_logic_vector field: 'Error' in reg: 'Read Timestamp control'
    wbrdtime_control_error_i                 : in     std_logic_vector(0 downto 0);
-- Port for std_logic_vector field: 'Correction' in reg: 'Read Timestamp control'
    wbrdtime_control_correction_i            : in     std_logic_vector(0 downto 0);
-- Ports for PASS_THROUGH field: 'Clear' in reg: 'Read Timestamp control'
    wbrdtime_control_clear_o                 : out    std_logic_vector(0 downto 0);
    wbrdtime_control_clear_wr_o              : out    std_logic
  );
end wb_readTimestamp;

architecture syn of wb_readTimestamp is

signal wbrdtime_control_disable_int             : std_logic_vector(0 downto 0);
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(2 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal bus_clock_int                            : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_data_i;
  bwsel_reg <= wb_sel_i;
  bus_clock_int <= wb_clk_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (bus_clock_int, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= std_logic_vector(to_unsigned(0, 10));
      ack_in_progress <= '0';
      rddata_reg <= std_logic_vector(to_unsigned(0, 32));
      wbrdtime_control_disable_int <= std_logic_vector(to_unsigned(0, 1));
      wbrdtime_control_clear_wr_o <= '0';
    elsif rising_edge(bus_clock_int) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          wbrdtime_control_clear_wr_o <= '0';
          ack_in_progress <= '0';
        else
          wbrdtime_control_clear_wr_o <= '0';
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(2 downto 0) is
          when "000" => 
            if (wb_we_i = '1') then
            else
              rddata_reg(31 downto 0) <= wbrdtime_high_timestamp_i;
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001" => 
            if (wb_we_i = '1') then
            else
              rddata_reg(31 downto 0) <= wbrdtime_low_timestamp_i;
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010" => 
            if (wb_we_i = '1') then
            else
              rddata_reg(31 downto 0) <= wbrdtime_errors_nr_i;
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011" => 
            if (wb_we_i = '1') then
            else
              rddata_reg(31 downto 0) <= wbrdtime_corrections_nr_i;
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100" => 
            if (wb_we_i = '1') then
              wbrdtime_control_disable_int <= wrdata_reg(0 downto 0);
              wbrdtime_control_clear_wr_o <= '1';
              rddata_reg(3) <= 'X';
              rddata_reg(4) <= 'X';
              rddata_reg(5) <= 'X';
              rddata_reg(6) <= 'X';
              rddata_reg(7) <= 'X';
              rddata_reg(8) <= 'X';
              rddata_reg(9) <= 'X';
              rddata_reg(10) <= 'X';
              rddata_reg(11) <= 'X';
              rddata_reg(12) <= 'X';
              rddata_reg(13) <= 'X';
              rddata_reg(14) <= 'X';
              rddata_reg(15) <= 'X';
              rddata_reg(16) <= 'X';
              rddata_reg(17) <= 'X';
              rddata_reg(18) <= 'X';
              rddata_reg(19) <= 'X';
              rddata_reg(20) <= 'X';
              rddata_reg(21) <= 'X';
              rddata_reg(22) <= 'X';
              rddata_reg(23) <= 'X';
              rddata_reg(24) <= 'X';
              rddata_reg(25) <= 'X';
              rddata_reg(26) <= 'X';
              rddata_reg(27) <= 'X';
              rddata_reg(28) <= 'X';
              rddata_reg(29) <= 'X';
              rddata_reg(30) <= 'X';
              rddata_reg(31) <= 'X';
            else
              rddata_reg(0 downto 0) <= wbrdtime_control_disable_int;
              rddata_reg(1 downto 1) <= wbrdtime_control_error_i;
              rddata_reg(2 downto 2) <= wbrdtime_control_correction_i;
            end if;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_data_o <= rddata_reg;
-- timestamp
-- timestamp
-- error_counter
-- correction_counter
-- disable
  wbrdtime_control_disable_o <= wbrdtime_control_disable_int;
-- Error
-- Correction
-- Clear
-- pass-through field: Clear in register: Read Timestamp control
  wbrdtime_control_clear_o <= wrdata_reg(3 downto 3);
  rwaddr_reg <= wb_addr_i;
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
